
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android JNI之JAVA与C++对象建立对称关联（JNI优化设计，确保JNI调用的稳定性） / 憋错料</title>

    <meta name="description" content="Android JNI之JAVA与C++对象建立对称关联（JNI优化设计，确保JNI调用的稳定性） 转载请声明:原文转自:http://www.cnblogs.com/xiezie/p/5930503.html Android JNI之JAVA与C++对象建立对称关联 1.JAVA对象持有C++对象的指针 在JAVA类中创建一个int类型的变量(如int mObj),用于储存C++对象的指针 在创建C++对象(如MyCPlusObj)的本地方法中,将C++对象的指针存入JAVA变量中(mObj) JNIEXPORT void JNICALL Java_nativeMethod (JNIEnv">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android JNI之JAVA与C++对象建立对称关联（JNI优化设计，确保JNI调用的稳定性）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>转载请声明：原文转自：<a href="http://www.cnblogs.com/xiezie/p/5930503.html" rel="external nofollow noreferrer">http://www.cnblogs.com/xiezie/p/5930503.html</a></p>
<h1>Android JNI之JAVA与C++对象建立对称关联</h1>
<h2>1.JAVA对象持有C++对象的指针</h2>
<ol>
<li>在JAVA类中创建一个int类型的变量（如int mObj），用于储存C++对象的指针</li>
<li>在创建C++对象（如MyCPlusObj）的本地方法中，将C++对象的指针存入JAVA变量中（mObj）</li>
</ol>

<pre>JNIEXPORT void JNICALL
Java_nativeMethod
(JNIEnv *env, jobject thiz) {
    MyCPlusObj *obj = new MyCPlusObj();
    jclass clazz = (jclass)(*env).GetObjectClass(thiz);
    jfieldID fid = (jfieldID)(*env).GetFieldID(clazz, "mObj", "I");
    (*env).SetIntField(thiz, fid, (jint)obj);
}</pre>

<ul>
<li>如果要取得C++对象，则通过mObj的获取C++对象的指针</p>

<pre>jclass objClazz = (jclass)env-&gt;GetObjectClass(obj);//obj为对应的JAVA对象
jfieldID fid = env-&gt;GetFieldID(objClazz, "mObj", "I");
jlong p = (jlong)env-&gt;GetObjectField(obj, fid);
MyCPlusObj *cPlusObj = (MyCPlusObj *)p;
//cPlusObj 为JAVA对象对应的C++对象</pre>
</li>
</ul>
<h2>2.C++对象持有JAVA对象的引用</h2>
<ol>
<li>在C++类中创建一个jint类型的变量（如jint mObj），用于储存JAVA对象的引用</li>
<li>在创建C++对象时，储存JAVA对象的引用</p>
<pre>jobject gThiz = (jobject)env-&gt;NewGlobalRef(thiz);//thiz为JAVA对象
(*obj).javaObj = (jint)gThiz;</pre>
</li>
</ol>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-12 02:52:01 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android JNI之JAVA与C++对象建立对称关联（JNI优化设计，确保JNI调用的稳定性）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLrJ7d3.html" rel="bookmark">Android数据库高手秘籍&lpar;四&rpar;&mdash;&mdash;使用LitePal建立表关联</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/guolin_blog/article/details/39207945 目前我们已经对LitePal的用法有了一定了解,学会了使用LitePal来创建表和升级表的方式,那么今天就让我们一起继续进阶,探究一下如何使用LitePal来建立表与表之间的关联关系.还没有看过前一篇文章的朋友建议先去参考 Android数据库高手秘籍(三)--使用LitePal升级表 . LitePal的项目地址是:https://github.com/LiteP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDkxre4.html" rel="bookmark">android中利用java反射原理将对象添加到sqlit数据库的万能方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				利用java的反射机制,我们可以得到对象里的方法列表,参数列表以及对应的值,那么我们就可以利用这些做一个万能的插入数据库的方法. 以下方法中表名要和数据库名一致. protected void insert(Object ob){ ContentValues initialValues = new ContentValues(); Class c = ob.getClass(); String className = c.getName(); String tableName = classNa			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXZp9X3.html" rel="bookmark">【我的Android进阶之旅】Android调用JNI出错 java&period;lang&period;UnsatisfiedLinkError&colon; No implementation found for的解决方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				错误描述 今天使用第三方的so库时候,调用JNI方法时出现了错误.报错如下所示: 11-01 16:39:20.979 4669-4669/com.netease.xtc.cloudmusic E/art: No implementation found for void com.netease.xtc.cloudmusic.utils.NeteaseMusicUtils.nativeInit(android.content.Context) (tried Java_com_netease_xt			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0l5W6Z3.html" rel="bookmark">Android JNI之JAVA调用C&sol;C&plus;&plus;层</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 转载请声明:原文转自:http://www.cnblogs.com/xiezie/p/5929996.html 一.java调用本地函数的开发步骤: 1.编写本地方法的类(可以说是用来叙述本地方法的类): 2.编译这个类,生成该类的.class文件 在Android Studio下有很多方法: 点击Make Project Clean Project + Rebuild Project 运行或Debug  APP 3.用javah命令生成该.class文件的.h头文件 在Android			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bRGo90.html" rel="bookmark">Android与JNI&lpar;二&rpar; ---- Java调用C 动态调用&lpar;转载&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				目录: 1. 简介 2. JNI 组件的入口函数 3. 使用 registerNativeMethods 方法 4. 测试 5. JNI 帮助方法 6. 参考资料 1. 简介 目录: 1. 简介 2. JNI 组件的入口函数 3. 使用 registerNativeMethods 方法 4. 测试 5. JNI 帮助方法 6. 参考资料 1. 简介 Android与JNI(一)已经简单介绍了如何在 android  环境下使用 JNI 了.但是遵循 JNI 开发的基本步骤似乎有点死板,而且得到的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0azGag3.html" rel="bookmark">Android数据库框架&mdash;&mdash;ORMLite轻量级的对象关系映射&lpar;ORM&rpar;Java包</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android数据库框架--ORMLite轻量级的对象关系映射(ORM)Java包 事实上,我想写数据库的念头已经很久了,在之前写了一个答题系统的小项目那只是初步的带了一下数据库,数据库是比较强大的,不是我们三言两语就能解决的,我一直想抽个时间自己再过一遍Sqlite和JDBC的,但是,大家也知道,琐事比较多,我们来说一下数据库的框架吧,事实上市面上,我觉得还可以的数据库框架有两个,ORMLite和GreenDao,我以前做的运动类的应用上,就需要存储大量的运动数据,我们最开始是在本地写数据库的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4A2JPbM.html" rel="bookmark">Android使用JNI实现Java与C之间传递数据（转）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				介绍Java如何将数据传递给C和C回调Java的方法.  java传递数据给C,在C代码中进行处理数据,处理完数据后返回给java.C的回调是Java传递数据给C,C需要用到Java中的某个方法,就需要调用java的方法. Android中使用JNI七个步骤: 1.创建一个android工程 2.JAVA代码中写声明native 方法 public native String helloFromJNI(); 3.用javah工具生成头文件 4. 创建jni目录,引入头文件,根据头文件实现c代码			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xXlLL0.html" rel="bookmark">android 学习随笔二十七（JNI：Java Native Interface&comma;JAVA原生接口 ）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JNI(Java Native Interface,JAVA原生接口) 使用JNI可以使Java代码和其他语言写的代码(如C/C++代码)进行交互. 问:为什么要进行交互? 首先,Java语言提供的类库无法满足要求,且在数学运算,实时渲染的游戏上,音视频处理等方面上与C/C++相比效率稍低. 然后,Java语言无法直接操作硬件,C/C++代码不仅能操作硬件而且还能发挥硬件最佳性能. 接着,使用Java调用本地的C/C++代码所写的库,省去了重复开发的麻烦,并且可以利用很多开源的库提高程序效率.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pqm8RM.html" rel="bookmark">android NDK 实用学习（三）- java端类对象的构造及使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1,读此文章前我假设你已经读过: android NDK 实用学习-获取java端类及其类变量 android NDK 实用学习-java端对象成员赋值和获取对象成员值 2,java端类对象的构造: ①首先获取类; ②获取类的无参构造函数: jmethodID initID = env-&gt;GetMethodID(jcSetDataMgr, &quot;&lt;init&gt;&quot;, &quot;()V&quot;); ③构造类实例: jobject jresult = env-&gt;New			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R8pZ54.html" rel="bookmark" class="title">我的女神&mdash;&mdash;简洁实用的iOS代码调试框架</a>
					<div>
						我的女神--简洁实用的iOS代码调试框架 一.引言 这篇博客的起源是接手了公司的一个已经完成的项目,来做代码优化,项目工程很大,并且引入了很多公司内部的SDK,要搞清楚公司内部的这套框架,的确不是件容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5DYK3.html" rel="bookmark" class="title">&lbrack;webgrid&rsqb; &amp;ndash&semi; selecterow - &lpar;Get Selected Row from ASP&period;NET MVC 3 WebGrid&rpar;</a>
					<div>
						Get Selected Row from ASP.NET MVC 3 WebGrid Abstract: The following article demonstrates how to get  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP85ZmM.html" rel="bookmark" class="title">SpringMvc项目中使用GoogleKaptcha 生成验证码</a>
					<div>
						SpringMvc项目中使用GoogleKaptcha 生成验证码 前言:google captcha 是google生成验证码的一个工具类,其原理是将随机生成字符串保存到session中,同时以图片 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEy9g0.html" rel="bookmark" class="title">java面试基础大全&comma;绝对经典&amp;lt&semi;51-95&amp;gt&semi;&amp;lt&semi;转&amp;gt&semi;</a>
					<div>
						51.类ExampleA继承Exception,类ExampleB继承ExampleA. 有如下代码片断: try { throw new ExampleB(&quot;b&quot;) } catc ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rvPev3.html" rel="bookmark" class="title">struts2 自定义校验规则</a>
					<div>
						自定义校验规则:(了解) 在Struts2自定义校验规则: 1.实现一个Validator 接口. 2.一般开发中继承ValidatorSupport 或者 FieldValidatorSupport ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDoXye4.html" rel="bookmark" class="title">Win10系统80端口被pid&equals;4的System进程占用 -- 解决方法</a>
					<div>
						背景: 今天在家里电脑下载phpstudy 2016后,准备启动服务器,结果提示80端口被占用 过程: 百度后有这几种解决方法: 1.IIS占用 2.SQL server 2008的报表服务占用 可惜 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4ARjnbM.html" rel="bookmark" class="title">Zabbix 监控Tomcat</a>
					<div>
						Zabbix监控Tomcat 一.环境 两台服务器,一台是Zabbix_java_Server ,另一台Tomcat-Server 需要用到的文件:catalina-jmx-remote.jar cm ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dAmD63.html" rel="bookmark" class="title">汉诺塔（3个圆盘）</a>
					<div>
						直接上代码吧 1 #include &lt;fstream&gt; 2 #include &lt;iostream&gt; 3 4 using namespace std; 5 6 int step= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nkmQP3.html" rel="bookmark" class="title">盒子模型阴影设置，爱奇艺阴影配置</a>
					<div>
						box-shadow的配置阴影 ul li:hover{ border-color: #dfdfdf; border-radius: 10px; -moz-box-shadow: 0 5px 5px  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXLkwwM.html" rel="bookmark" class="title">使用jQuery实现伪分页</a>
					<div>
						在之前的项目中遇到一个这样的问题,页面分为上下两部分(分别称为未选中设备信息部分和选中设备信息部分),上面是从数据库拿出来的所有的设备信息,下面是显式已选中的设备信息,页面如下所示: 可以选中其中的任 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/478XeYM.html" rel="bookmark" class="title">使用 Android 的日志工具LogCat</a>
					<div>
						Android 中的日志工具类是 Log(android.util.Log),这个类中提供了如下几个方法来供我们打印日志. 1.    Log.v() 这个方法用于打印那些最为琐碎的,意义最小的日志信 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WwAA0.html" rel="bookmark" class="title">kali&mdash;&mdash;安装chrome</a>
					<div>
						1.下载chrome kali使用的debian的系统,所以需要下载deb的安装包.可以通过chrome的官网下载(当然F--Q是前提),也可以从网盘下载: 2.dpkg安装 将文件cp至目录下,使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Nqmjo3.html" rel="bookmark" class="title">ZendFramwork配置</a>
					<div>
						启动顺序 \public\index.php        入口总控初始化     $application-&gt;bootstrap()-&gt;run() \application\Bootst ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODrJ74.html" rel="bookmark" class="title">sed命令基础用法</a>
					<div>
						    sed(Stream EDitor)简介 sed是一个流编辑器编辑器,本身是一个管道命令,主要以行为单位处理文本文件,可以将数据进行替换.删除.新增.选取等特定工作:sed并不会处理文本文件本 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZ7YX0.html" rel="bookmark" class="title">基于zepto的插件之移动端无缝向上滚动并上下触摸滑动</a>
					<div>
						该插件乃本博客作者所写,目的在于提升作者的js能力,也给一些js菜鸟在使用插件时提供一些便利,老鸟就悠然地飞过吧. 公司的移动端项目是基于zepto的,有一个页面要求文字能够无缝地不停向上滚动,但查了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MERP7g0.html" rel="bookmark" class="title">centos下安装jenkins</a>
					<div>
						1.去jenkins官网下载最新版本的rpm安装包,https://jenkins.io/index.html jenkins-2.7.4-1.1.noarch.rpm 2.安装JDK yum ins ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nPOgo4.html" rel="bookmark" class="title">SQL Server之游标的基础知识</a>
					<div>
						什么是游标: 游标是可以在结果集中上下游动的指针. 游标的作用: --允许定位到结果集中的特定行. --从结果集的当前位置检索一行或多行数据. --支持对结果集中当前位置的行进行修改. 注意:游标虽然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgRAEL4.html" rel="bookmark" class="title">R语言统计分析-方差分析</a>
					<div>
						R语言统计分析-方差分析 一.方差分析简单的例子 测试6中杀虫剂的效果,目标值为虫子个数,对方差进行分析. 1.导入数据 data(InsectSprays) 2.平方根转换,分析 aov.spray ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nen9pM.html" rel="bookmark" class="title">谷歌google搜索打不开、谷歌gmail邮箱及相关服务无法登录的解决的方法</a>
					<div>
						歌打不开 google打不开,与中国大陆封杀有关,可是主要是由于近期googleserver在全球范围内又一次进行了布局调整. 解决的方法是仅仅要改动用户本地计算机hosts文件就能够了. 一.Win ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35NV7j4.html" rel="bookmark" class="title">十大编程算法助程序员走上大神之路</a>
					<div>
						概述:编程算法,是完成程序逻辑的主要途径.本文推荐十大编程算法,有利于程序员的编程逻辑. 算法一:快速排序算法 快速排序是由东尼·霍尔所发展的一种排序算法.在平均状况下,排序 n 个项目要Ο(n lo ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
